<?php
namespace Geral\Logic;

class montaStringMultiSearchLogic {

	public static function multiSearch($field, $tabela, $coluna, $coluna_busca=null)
    {
    	/*
    	Recebe o nome do field da tab, o nome da tabela e o da coluna da tabela.
    	Seta os valores do field em uma variavel e chama a função abaixo para montar a string.
    	*/
    	if ($coluna_busca == null)
    		$coluna_busca = $coluna;
    	
        $multisearch = tk_get_field_value(strtoupper($field));

        if(($multisearch !== "A") && ($multisearch !== "N") && (!empty($multisearch)))
        {
            $filtro = "'";
            foreach($multisearch as $search)
            {
                $campo = $search[strtolower($coluna_busca)];
                $filtro .= $campo."','";
            }
        }
        else
        {
            $filtro = "T";
        }
        $substring = substr($filtro,0,(strlen($filtro)-2));
        // Tira o ', que foi concatenado ao final
        return self::where($substring, strtoupper($tabela), strtoupper($coluna));
    }

    static function where($filtro, $tabela, $coluna)
    {
    	/*
    	Recebe os valores a filtrar e monta uma string utilizando IN.
    	É necessário utilizar um substr para retirar o AND que é concatenado ao final.
    	*/
        $where = "";
        if ($filtro != ""){
            $where .= "$tabela.$coluna IN ($filtro) AND ";
        }
        return $where;
    }

    public static function multiSearchDeArray($multisearch, $tabela, $coluna, $coluna_busca=null)
    {
        /*
        Faz o mesmo que a primeira função, mas ao invés de receber o field que contém o array do multisearch como parâmetro, recebe direto o próprio array.
        */
        if ($coluna_busca == null)
            $coluna_busca = $coluna;

        if($multisearch !== "A" && $multisearch !== "N")
        {
            $filtro = "'";
            foreach($multisearch as $search)
            {
                $campo = $search[strtolower($coluna_busca)];
                $filtro .= $campo."','";
            }
        }
        else
        {
            $filtro = "T";
        }
        $substring = substr($filtro,0,(strlen($filtro)-2));
        // Tira o ', que foi concatenado ao final
        return self::where($substring, strtoupper($tabela), strtoupper($coluna));
    }
}